-----------------------------------------------------------------------------
--  IBM*                                                                  
--  Licensed Materials - Property of IBM                                  
--  5765-F38                                                              
--  (C) Copyright IBM Corporation 2001,2002                               
--  All rights reserved.                                                  
--                                                                        
-- * Trademark of International Business Machines                         
-----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- DB2 Net Search Extender UDFs
--
-- these statements have been generated 
-- don't modify this file
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- internal UDFs for rewriter (SVF/TVF)
-- ----------------------------------------------------------------------------

create function db2ext.textSearch_1K16
        (
                indexName	VARCHAR(128),
                indexCreator	VARCHAR(128),
                indexProps      VARCHAR(1024) FOR BIT DATA,
                textSearchArg   VARCHAR(4096),
                plan            VARCHAR(4096) FOR BIT DATA,
                primKeyBinding  VARCHAR(1056) FOR BIT DATA
        )
        disallow parallel
        returns table
        (
                primKey         VARCHAR(1056) FOR BIT DATA,
                contains        INTEGER,
                numberofmatches INTEGER,
                score           DOUBLE
        )
        specific CTE21
        external name 'libcteue.so!CteTextSearchTF'
        language C
        parameter style db2sql
        deterministic
        fenced
        called on null input
        no sql
        no external action
        scratchpad
        final call
        dbinfo
        cardinality 2;


create function db2ext.contains_1K16
        (
                primKey          VARCHAR(1056) FOR BIT DATA,
                indexName        VARCHAR(128),
                indexCreator     VARCHAR(128),
                indexProps       VARCHAR(1024) FOR BIT DATA,
                textSearchArg    VARCHAR(4096)
        )
        returns INTEGER
        specific CTE1A1
        external name 'libcteue.so!CteTextSearchSF_C1'
        language C
        parameter style db2sql
        deterministic
        fenced
        called on null input
        no sql
        no external action
        scratchpad 
        final call
        dbinfo
        disallow parallel;


create function db2ext.nmatches_1K16
        (
                primKey          VARCHAR(1056) FOR BIT DATA,
                indexName        VARCHAR(128),
                indexCreator     VARCHAR(128),
                indexProps       VARCHAR(1024) FOR BIT DATA,
                textSearchArg    VARCHAR(4096)
        )
        returns INTEGER
        specific CTE1B1
        external name 'libcteue.so!CteTextSearchSF_N1'
        language C
        parameter style db2sql
        deterministic
        fenced
        called on null input
        no sql
        no external action
        scratchpad 
        final call
        dbinfo
        disallow parallel;


create function db2ext.score_1K16
        (
                primKey          VARCHAR(1056) FOR BIT DATA,
                indexName        VARCHAR(128),
                indexCreator     VARCHAR(128),
                indexProps       VARCHAR(1024) FOR BIT DATA,
                textSearchArg    VARCHAR(4096)
        )
        returns DOUBLE
        specific CTE1C1
        external name 'libcteue.so!CteTextSearchSF_S1'
        language C
        parameter style db2sql
        deterministic
        fenced
        called on null input
        no sql
        no external action
        scratchpad 
        final call
        dbinfo
        disallow parallel;


GRANT EXECUTE ON FUNCTION db2ext.textSearch_1K16 (
 VARCHAR(128), VARCHAR(128), VARCHAR(1024), VARCHAR(4096),
 VARCHAR(4096) FOR BIT DATA, VARCHAR(1056) FOR BIT DATA )
TO PUBLIC;

GRANT EXECUTE ON FUNCTION db2ext.contains_1K16 (
 VARCHAR(1056) FOR BIT DATA, VARCHAR(128), VARCHAR(128),
 VARCHAR(1024) FOR BIT DATA, VARCHAR(4096))
TO PUBLIC;

GRANT EXECUTE ON FUNCTION db2ext.nmatches_1K16 (
 VARCHAR(1056) FOR BIT DATA, VARCHAR(128), VARCHAR(128),
 VARCHAR(1024) FOR BIT DATA, VARCHAR(4096))
TO PUBLIC;

GRANT EXECUTE ON FUNCTION db2ext.score_1K16 (
  VARCHAR(1056) FOR BIT DATA, VARCHAR(128), VARCHAR(128),
  VARCHAR(1024) FOR BIT DATA, VARCHAR(4096))
TO PUBLIC;

----------------------------------------------------------------------------
-- internal table function used as backend for all external table functions
-- 
-- Don't change specific name prefix CTEBE (used to determine whether we are
-- in an external TF call scenario or an internal TF call scenario produced
-- by the optimizer)
--
-- Don't change the order of the first 4 return columns (need to be the same
-- as for the internal TF because CteTextSearchTF checks dbinfo to determine 
-- whether score values have to be returned)
--
----------------------------------------------------------------------------

create function db2ext.textSearch_be1
        (
                indexName        VARCHAR(128),
                indexCreator     VARCHAR(128),
                indexProps       VARCHAR(1024) FOR BIT DATA,
                textSearchArg    VARCHAR(4096),
                plan             VARCHAR(4096) FOR BIT DATA,
                primKeyBinding   VARCHAR(1056) FOR BIT DATA,
                resultFirstRow   INTEGER,
                resultNumberRows INTEGER,
                numberOfHits     INTEGER
        )
        disallow parallel
        returns table
        (
                primKey          VARCHAR(1056) FOR BIT DATA,
                contains         INTEGER,
                numberofmatches  INTEGER,
                score            DOUBLE,
                totalNbResults   INTEGER,
                searchTermCounts VARCHAR(4000),
                hitInformation   BLOB(20K)
        )
        specific CTEBE1
        external name 'libcteue.so!CteTextSearch_BE1'
        language C
        parameter style db2sql
        deterministic
        fenced
        called on null input
        no sql
        no external action
        scratchpad
        final call
        dbinfo
        cardinality 1;

GRANT EXECUTE ON FUNCTION db2ext.textSearch_be1 TO PUBLIC;

----------------------------------------------------------------------------
-- Functions for >SMALLINT<
----------------------------------------------------------------------------

----------------------------------------------------------------------------
-- unpack_text_key functions reverting the packed key representations
-- build by sysibm.pack_text_key
----------------------------------------------------------------------------

create function db2ext.unpack_text_key
        (
                primKey VARCHAR(1056) FOR BIT DATA,
                dummy   SMALLINT
        )
        returns SMALLINT
        specific CTEU1
        external name 'libcteue.so!CteUnpackTextKeySint'
        language C
        parameter style db2sql
        deterministic
        not fenced
        no sql
        no external action
        called on null input
        disallow parallel;

GRANT EXECUTE ON FUNCTION db2ext.unpack_text_key
        ( VARCHAR(1056) FOR BIT DATA, SMALLINT)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   SMALLINT
        )
        returns table
        (
                primKey         SMALLINT,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
           SELECT db2ext.unpack_text_key(TF.primkey, cast (NULL as SMALLINT)),
                  TF.numberofmatches,
                  TF.score,
                  TF.totalNbResults
           FROM   tmptbl2 tmp,
                  table( db2ext.textSearch_be1(
                         tmp.tmpIndexName2,
                         'DB2EXT',
                         tmp.tmpIndexProps2,
                         pTextSearchArg,
                         cast (NULL as varchar(4096)),
                         sysibm.pack_text_key(pPrimKeyBinding),
                         pResultFirstRow,
                         pResultNumberRows,
                         cast (NULL as integer))) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  SMALLINT)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper with highlight info
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   SMALLINT,
                pNumberOfHits     INTEGER
        )
        returns table
        (
                primKey         SMALLINT,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER,
                hitInformation  BLOB(20K)
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
        SELECT  db2ext.unpack_text_key(TF.primkey, cast (NULL as SMALLINT)),
                TF.numberofmatches,
                TF.score,
                TF.totalNbResults,
                TF.hitInformation
        FROM    tmptbl2 tmp,
                table( db2ext.textSearch_be1(
                       tmp.tmpIndexName2,
                       'DB2EXT',
                       tmp.tmpIndexProps2,
                       pTextSearchArg,
                       cast (NULL as varchar(4096)),
                       sysibm.pack_text_key(pPrimKeyBinding),
                       pResultFirstRow,
                       pResultNumberRows,
                       pNumberOfHits)) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  SMALLINT, INTEGER)
TO PUBLIC;

----------------------------------------------------------------------------
-- Functions for >INTEGER<
----------------------------------------------------------------------------

----------------------------------------------------------------------------
-- unpack_text_key functions reverting the packed key representations
-- build by sysibm.pack_text_key
----------------------------------------------------------------------------

create function db2ext.unpack_text_key
        (
                primKey VARCHAR(1056) FOR BIT DATA,
                dummy   INTEGER
        )
        returns INTEGER
        specific CTEU2
        external name 'libcteue.so!CteUnpackTextKeyInt'
        language C
        parameter style db2sql
        deterministic
        not fenced
        no sql
        no external action
        called on null input
        disallow parallel;

GRANT EXECUTE ON FUNCTION db2ext.unpack_text_key
        ( VARCHAR(1056) FOR BIT DATA, INTEGER)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   INTEGER
        )
        returns table
        (
                primKey         INTEGER,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
           SELECT db2ext.unpack_text_key(TF.primkey, cast (NULL as INTEGER)),
                  TF.numberofmatches,
                  TF.score,
                  TF.totalNbResults
           FROM   tmptbl2 tmp,
                  table( db2ext.textSearch_be1(
                         tmp.tmpIndexName2,
                         'DB2EXT',
                         tmp.tmpIndexProps2,
                         pTextSearchArg,
                         cast (NULL as varchar(4096)),
                         sysibm.pack_text_key(pPrimKeyBinding),
                         pResultFirstRow,
                         pResultNumberRows,
                         cast (NULL as integer))) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  INTEGER)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper with highlight info
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   INTEGER,
                pNumberOfHits     INTEGER
        )
        returns table
        (
                primKey         INTEGER,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER,
                hitInformation  BLOB(20K)
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
        SELECT  db2ext.unpack_text_key(TF.primkey, cast (NULL as INTEGER)),
                TF.numberofmatches,
                TF.score,
                TF.totalNbResults,
                TF.hitInformation
        FROM    tmptbl2 tmp,
                table( db2ext.textSearch_be1(
                       tmp.tmpIndexName2,
                       'DB2EXT',
                       tmp.tmpIndexProps2,
                       pTextSearchArg,
                       cast (NULL as varchar(4096)),
                       sysibm.pack_text_key(pPrimKeyBinding),
                       pResultFirstRow,
                       pResultNumberRows,
                       pNumberOfHits)) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  INTEGER, INTEGER)
TO PUBLIC;

----------------------------------------------------------------------------
-- Functions for >BIGINT<
----------------------------------------------------------------------------

----------------------------------------------------------------------------
-- unpack_text_key functions reverting the packed key representations
-- build by sysibm.pack_text_key
----------------------------------------------------------------------------

create function db2ext.unpack_text_key
        (
                primKey VARCHAR(1056) FOR BIT DATA,
                dummy   BIGINT
        )
        returns BIGINT
        specific CTEU3
        external name 'libcteue.so!CteUnpackTextKeyBint'
        language C
        parameter style db2sql
        deterministic
        not fenced
        no sql
        no external action
        called on null input
        disallow parallel;

GRANT EXECUTE ON FUNCTION db2ext.unpack_text_key
        ( VARCHAR(1056) FOR BIT DATA, BIGINT)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   BIGINT
        )
        returns table
        (
                primKey         BIGINT,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
           SELECT db2ext.unpack_text_key(TF.primkey, cast (NULL as BIGINT)),
                  TF.numberofmatches,
                  TF.score,
                  TF.totalNbResults
           FROM   tmptbl2 tmp,
                  table( db2ext.textSearch_be1(
                         tmp.tmpIndexName2,
                         'DB2EXT',
                         tmp.tmpIndexProps2,
                         pTextSearchArg,
                         cast (NULL as varchar(4096)),
                         sysibm.pack_text_key(pPrimKeyBinding),
                         pResultFirstRow,
                         pResultNumberRows,
                         cast (NULL as integer))) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  BIGINT)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper with highlight info
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   BIGINT,
                pNumberOfHits     INTEGER
        )
        returns table
        (
                primKey         BIGINT,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER,
                hitInformation  BLOB(20K)
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
        SELECT  db2ext.unpack_text_key(TF.primkey, cast (NULL as BIGINT)),
                TF.numberofmatches,
                TF.score,
                TF.totalNbResults,
                TF.hitInformation
        FROM    tmptbl2 tmp,
                table( db2ext.textSearch_be1(
                       tmp.tmpIndexName2,
                       'DB2EXT',
                       tmp.tmpIndexProps2,
                       pTextSearchArg,
                       cast (NULL as varchar(4096)),
                       sysibm.pack_text_key(pPrimKeyBinding),
                       pResultFirstRow,
                       pResultNumberRows,
                       pNumberOfHits)) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  BIGINT, INTEGER)
TO PUBLIC;

----------------------------------------------------------------------------
-- Functions for >REAL<
----------------------------------------------------------------------------

----------------------------------------------------------------------------
-- unpack_text_key functions reverting the packed key representations
-- build by sysibm.pack_text_key
----------------------------------------------------------------------------

create function db2ext.unpack_text_key
        (
                primKey VARCHAR(1056) FOR BIT DATA,
                dummy   REAL
        )
        returns REAL
        specific CTEU4
        external name 'libcteue.so!CteUnpackTextKeyReal'
        language C
        parameter style db2sql
        deterministic
        not fenced
        no sql
        no external action
        called on null input
        disallow parallel;

GRANT EXECUTE ON FUNCTION db2ext.unpack_text_key
        ( VARCHAR(1056) FOR BIT DATA, REAL)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   REAL
        )
        returns table
        (
                primKey         REAL,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
           SELECT db2ext.unpack_text_key(TF.primkey, cast (NULL as REAL)),
                  TF.numberofmatches,
                  TF.score,
                  TF.totalNbResults
           FROM   tmptbl2 tmp,
                  table( db2ext.textSearch_be1(
                         tmp.tmpIndexName2,
                         'DB2EXT',
                         tmp.tmpIndexProps2,
                         pTextSearchArg,
                         cast (NULL as varchar(4096)),
                         sysibm.pack_text_key(pPrimKeyBinding),
                         pResultFirstRow,
                         pResultNumberRows,
                         cast (NULL as integer))) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  REAL)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper with highlight info
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   REAL,
                pNumberOfHits     INTEGER
        )
        returns table
        (
                primKey         REAL,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER,
                hitInformation  BLOB(20K)
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
        SELECT  db2ext.unpack_text_key(TF.primkey, cast (NULL as REAL)),
                TF.numberofmatches,
                TF.score,
                TF.totalNbResults,
                TF.hitInformation
        FROM    tmptbl2 tmp,
                table( db2ext.textSearch_be1(
                       tmp.tmpIndexName2,
                       'DB2EXT',
                       tmp.tmpIndexProps2,
                       pTextSearchArg,
                       cast (NULL as varchar(4096)),
                       sysibm.pack_text_key(pPrimKeyBinding),
                       pResultFirstRow,
                       pResultNumberRows,
                       pNumberOfHits)) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  REAL, INTEGER)
TO PUBLIC;

----------------------------------------------------------------------------
-- Functions for >DOUBLE<
----------------------------------------------------------------------------

----------------------------------------------------------------------------
-- unpack_text_key functions reverting the packed key representations
-- build by sysibm.pack_text_key
----------------------------------------------------------------------------

create function db2ext.unpack_text_key
        (
                primKey VARCHAR(1056) FOR BIT DATA,
                dummy   DOUBLE
        )
        returns DOUBLE
        specific CTEU5
        external name 'libcteue.so!CteUnpackTextKeyDouble'
        language C
        parameter style db2sql
        deterministic
        not fenced
        no sql
        no external action
        called on null input
        disallow parallel;

GRANT EXECUTE ON FUNCTION db2ext.unpack_text_key
        ( VARCHAR(1056) FOR BIT DATA, DOUBLE)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   DOUBLE
        )
        returns table
        (
                primKey         DOUBLE,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
           SELECT db2ext.unpack_text_key(TF.primkey, cast (NULL as DOUBLE)),
                  TF.numberofmatches,
                  TF.score,
                  TF.totalNbResults
           FROM   tmptbl2 tmp,
                  table( db2ext.textSearch_be1(
                         tmp.tmpIndexName2,
                         'DB2EXT',
                         tmp.tmpIndexProps2,
                         pTextSearchArg,
                         cast (NULL as varchar(4096)),
                         sysibm.pack_text_key(pPrimKeyBinding),
                         pResultFirstRow,
                         pResultNumberRows,
                         cast (NULL as integer))) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  DOUBLE)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper with highlight info
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   DOUBLE,
                pNumberOfHits     INTEGER
        )
        returns table
        (
                primKey         DOUBLE,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER,
                hitInformation  BLOB(20K)
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
        SELECT  db2ext.unpack_text_key(TF.primkey, cast (NULL as DOUBLE)),
                TF.numberofmatches,
                TF.score,
                TF.totalNbResults,
                TF.hitInformation
        FROM    tmptbl2 tmp,
                table( db2ext.textSearch_be1(
                       tmp.tmpIndexName2,
                       'DB2EXT',
                       tmp.tmpIndexProps2,
                       pTextSearchArg,
                       cast (NULL as varchar(4096)),
                       sysibm.pack_text_key(pPrimKeyBinding),
                       pResultFirstRow,
                       pResultNumberRows,
                       pNumberOfHits)) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  DOUBLE, INTEGER)
TO PUBLIC;

----------------------------------------------------------------------------
-- Functions for >VARCHAR(255) FOR BIT DATA<
----------------------------------------------------------------------------

----------------------------------------------------------------------------
-- unpack_text_key functions reverting the packed key representations
-- build by sysibm.pack_text_key
----------------------------------------------------------------------------

create function db2ext.unpack_text_key
        (
                primKey VARCHAR(1056) FOR BIT DATA,
                dummy   VARCHAR(255) FOR BIT DATA
        )
        returns VARCHAR(255) FOR BIT DATA
        specific CTEU6
        external name 'libcteue.so!CteUnpackTextKeyVfbd'
        language C
        parameter style db2sql
        deterministic
        not fenced
        no sql
        no external action
        called on null input
        disallow parallel;

GRANT EXECUTE ON FUNCTION db2ext.unpack_text_key
        ( VARCHAR(1056) FOR BIT DATA, VARCHAR(255) FOR BIT DATA)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   VARCHAR(255) FOR BIT DATA
        )
        returns table
        (
                primKey         VARCHAR(255) FOR BIT DATA,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
           SELECT db2ext.unpack_text_key(TF.primkey, cast (NULL as VARCHAR(255) FOR BIT DATA)),
                  TF.numberofmatches,
                  TF.score,
                  TF.totalNbResults
           FROM   tmptbl2 tmp,
                  table( db2ext.textSearch_be1(
                         tmp.tmpIndexName2,
                         'DB2EXT',
                         tmp.tmpIndexProps2,
                         pTextSearchArg,
                         cast (NULL as varchar(4096)),
                         sysibm.pack_text_key(pPrimKeyBinding),
                         pResultFirstRow,
                         pResultNumberRows,
                         cast (NULL as integer))) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  VARCHAR(255) FOR BIT DATA)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper with highlight info
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   VARCHAR(255) FOR BIT DATA,
                pNumberOfHits     INTEGER
        )
        returns table
        (
                primKey         VARCHAR(255) FOR BIT DATA,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER,
                hitInformation  BLOB(20K)
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
        SELECT  db2ext.unpack_text_key(TF.primkey, cast (NULL as VARCHAR(255) FOR BIT DATA)),
                TF.numberofmatches,
                TF.score,
                TF.totalNbResults,
                TF.hitInformation
        FROM    tmptbl2 tmp,
                table( db2ext.textSearch_be1(
                       tmp.tmpIndexName2,
                       'DB2EXT',
                       tmp.tmpIndexProps2,
                       pTextSearchArg,
                       cast (NULL as varchar(4096)),
                       sysibm.pack_text_key(pPrimKeyBinding),
                       pResultFirstRow,
                       pResultNumberRows,
                       pNumberOfHits)) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  VARCHAR(255) FOR BIT DATA, INTEGER)
TO PUBLIC;

----------------------------------------------------------------------------
-- Functions for >DATE<
----------------------------------------------------------------------------

----------------------------------------------------------------------------
-- unpack_text_key functions reverting the packed key representations
-- build by sysibm.pack_text_key
----------------------------------------------------------------------------

create function db2ext.unpack_text_key
        (
                primKey VARCHAR(1056) FOR BIT DATA,
                dummy   DATE
        )
        returns DATE
        specific CTEU7
        external name 'libcteue.so!CteUnpackTextKeyDate'
        language C
        parameter style db2sql
        deterministic
        not fenced
        no sql
        no external action
        called on null input
        disallow parallel;

GRANT EXECUTE ON FUNCTION db2ext.unpack_text_key
        ( VARCHAR(1056) FOR BIT DATA, DATE)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   DATE
        )
        returns table
        (
                primKey         DATE,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
           SELECT db2ext.unpack_text_key(TF.primkey, cast (NULL as DATE)),
                  TF.numberofmatches,
                  TF.score,
                  TF.totalNbResults
           FROM   tmptbl2 tmp,
                  table( db2ext.textSearch_be1(
                         tmp.tmpIndexName2,
                         'DB2EXT',
                         tmp.tmpIndexProps2,
                         pTextSearchArg,
                         cast (NULL as varchar(4096)),
                         sysibm.pack_text_key(pPrimKeyBinding),
                         pResultFirstRow,
                         pResultNumberRows,
                         cast (NULL as integer))) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  DATE)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper with highlight info
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   DATE,
                pNumberOfHits     INTEGER
        )
        returns table
        (
                primKey         DATE,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER,
                hitInformation  BLOB(20K)
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
        SELECT  db2ext.unpack_text_key(TF.primkey, cast (NULL as DATE)),
                TF.numberofmatches,
                TF.score,
                TF.totalNbResults,
                TF.hitInformation
        FROM    tmptbl2 tmp,
                table( db2ext.textSearch_be1(
                       tmp.tmpIndexName2,
                       'DB2EXT',
                       tmp.tmpIndexProps2,
                       pTextSearchArg,
                       cast (NULL as varchar(4096)),
                       sysibm.pack_text_key(pPrimKeyBinding),
                       pResultFirstRow,
                       pResultNumberRows,
                       pNumberOfHits)) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  DATE, INTEGER)
TO PUBLIC;

----------------------------------------------------------------------------
-- Functions for >TIME<
----------------------------------------------------------------------------

----------------------------------------------------------------------------
-- unpack_text_key functions reverting the packed key representations
-- build by sysibm.pack_text_key
----------------------------------------------------------------------------

create function db2ext.unpack_text_key
        (
                primKey VARCHAR(1056) FOR BIT DATA,
                dummy   TIME
        )
        returns TIME
        specific CTEU8
        external name 'libcteue.so!CteUnpackTextKeyTime'
        language C
        parameter style db2sql
        deterministic
        not fenced
        no sql
        no external action
        called on null input
        disallow parallel;

GRANT EXECUTE ON FUNCTION db2ext.unpack_text_key
        ( VARCHAR(1056) FOR BIT DATA, TIME)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   TIME
        )
        returns table
        (
                primKey         TIME,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
           SELECT db2ext.unpack_text_key(TF.primkey, cast (NULL as TIME)),
                  TF.numberofmatches,
                  TF.score,
                  TF.totalNbResults
           FROM   tmptbl2 tmp,
                  table( db2ext.textSearch_be1(
                         tmp.tmpIndexName2,
                         'DB2EXT',
                         tmp.tmpIndexProps2,
                         pTextSearchArg,
                         cast (NULL as varchar(4096)),
                         sysibm.pack_text_key(pPrimKeyBinding),
                         pResultFirstRow,
                         pResultNumberRows,
                         cast (NULL as integer))) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  TIME)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper with highlight info
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   TIME,
                pNumberOfHits     INTEGER
        )
        returns table
        (
                primKey         TIME,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER,
                hitInformation  BLOB(20K)
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
        SELECT  db2ext.unpack_text_key(TF.primkey, cast (NULL as TIME)),
                TF.numberofmatches,
                TF.score,
                TF.totalNbResults,
                TF.hitInformation
        FROM    tmptbl2 tmp,
                table( db2ext.textSearch_be1(
                       tmp.tmpIndexName2,
                       'DB2EXT',
                       tmp.tmpIndexProps2,
                       pTextSearchArg,
                       cast (NULL as varchar(4096)),
                       sysibm.pack_text_key(pPrimKeyBinding),
                       pResultFirstRow,
                       pResultNumberRows,
                       pNumberOfHits)) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  TIME, INTEGER)
TO PUBLIC;

----------------------------------------------------------------------------
-- Functions for >TIMESTAMP<
----------------------------------------------------------------------------

----------------------------------------------------------------------------
-- unpack_text_key functions reverting the packed key representations
-- build by sysibm.pack_text_key
----------------------------------------------------------------------------

create function db2ext.unpack_text_key
        (
                primKey VARCHAR(1056) FOR BIT DATA,
                dummy   TIMESTAMP
        )
        returns TIMESTAMP
        specific CTEU9
        external name 'libcteue.so!CteUnpackTextKeyStamp'
        language C
        parameter style db2sql
        deterministic
        not fenced
        no sql
        no external action
        called on null input
        disallow parallel;

GRANT EXECUTE ON FUNCTION db2ext.unpack_text_key
        ( VARCHAR(1056) FOR BIT DATA, TIMESTAMP)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   TIMESTAMP
        )
        returns table
        (
                primKey         TIMESTAMP,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
           SELECT db2ext.unpack_text_key(TF.primkey, cast (NULL as TIMESTAMP)),
                  TF.numberofmatches,
                  TF.score,
                  TF.totalNbResults
           FROM   tmptbl2 tmp,
                  table( db2ext.textSearch_be1(
                         tmp.tmpIndexName2,
                         'DB2EXT',
                         tmp.tmpIndexProps2,
                         pTextSearchArg,
                         cast (NULL as varchar(4096)),
                         sysibm.pack_text_key(pPrimKeyBinding),
                         pResultFirstRow,
                         pResultNumberRows,
                         cast (NULL as integer))) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  TIMESTAMP)
TO PUBLIC;

----------------------------------------------------------------------------
-- external table function wrapper with highlight info
----------------------------------------------------------------------------

create function db2ext.textSearch
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   TIMESTAMP,
                pNumberOfHits     INTEGER
        )
        returns table
        (
                primKey         TIMESTAMP,
                numberofmatches INTEGER,
                score           DOUBLE,
                totalNbResults  INTEGER,
                hitInformation  BLOB(20K)
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as
                (SELECT C.indexidentifier, C.indexproperties
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema= pIndexCreator and
                        I.indexname=pIndexName
                ),
                tmptbl2 (tmpIndexName2, tmpIndexProps2) as
                (SELECT T.tmpIndexName,
                        CASE
                           WHEN T.tmpIndexProps IS NOT NULL
                                THEN T.tmpIndexProps
                           ELSE pIndexCreator || '.' || pIndexName
                        END
                 FROM   sysibm.sysdummy1 D LEFT OUTER JOIN tmptbl T
                        ON D.IBMREQD = 'Y')
        SELECT  db2ext.unpack_text_key(TF.primkey, cast (NULL as TIMESTAMP)),
                TF.numberofmatches,
                TF.score,
                TF.totalNbResults,
                TF.hitInformation
        FROM    tmptbl2 tmp,
                table( db2ext.textSearch_be1(
                       tmp.tmpIndexName2,
                       'DB2EXT',
                       tmp.tmpIndexProps2,
                       pTextSearchArg,
                       cast (NULL as varchar(4096)),
                       sysibm.pack_text_key(pPrimKeyBinding),
                       pResultFirstRow,
                       pResultNumberRows,
                       pNumberOfHits)) TF;

GRANT EXECUTE ON FUNCTION db2ext.textSearch (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  TIMESTAMP, INTEGER)
TO PUBLIC;

-- ----------------------------------------------------------------------------
-- internally used UDFs (in views etc.)
-- ----------------------------------------------------------------------------

create function db2ext.REORG_SUGGESTED
        (
                indexName  VARCHAR(128),
                VARCHAR(1024) FOR BIT DATA 
        )
        returns INTEGER
        specific CTE3A
        external name 'libcteui.so!CteIsMergeRecommended'
        language C
        parameter style db2sql
        deterministic
        fenced
        returns null on null input
        no sql
        no external action
        allow parallel
        dbinfo;

create function db2ext.NUMBER_DOCS
        (
                indexName  VARCHAR(128),
                VARCHAR(1024) FOR BIT DATA 
        )
        returns INTEGER
        specific CTE3B
        external name 'libcteui.so!CteNumberOfDocuments'
        language C
        parameter style db2sql
        deterministic
        fenced
        returns null on null input
        no sql
        no external action
        allow parallel
        dbinfo;

GRANT EXECUTE ON FUNCTION db2ext.REORG_SUGGESTED TO PUBLIC;
GRANT EXECUTE ON FUNCTION db2ext.NUMBER_DOCS TO PUBLIC;

----------------------------------------------------------------------------
-- returns attribute expressionlist delimited by A0'0 ... A0'1 expressions
----------------------------------------------------------------------------

CREATE FUNCTION DB2EXT.attributeExpr(e CLOB(32K))
RETURNS VARCHAR(32000)
LANGUAGE SQL NO EXTERNAL ACTION
DETERMINISTIC
RETURN case when posstr(e, 'A0''0') > 0 
            then substr(e, posstr(e, 'A0''0')+ 4, 
                           posstr(e, 'A0''1')-posstr(e,'A0''0')-4)
            else null
       end;

GRANT EXECUTE ON FUNCTION DB2EXT.attributeExpr TO PUBLIC;

----------------------------------------------------------------------------
-- returns returns 1 if operands are equal, else 0.
-- Difference to = operator: equals(null,null)=1 !                  
----------------------------------------------------------------------------

CREATE FUNCTION DB2EXT.EQUAL(p1 VARCHAR(32000),
                             p2 VARCHAR(32000))
RETURNS INTEGER
LANGUAGE SQL
NO EXTERNAL ACTION
DETERMINISTIC
RETURN case when (p1 is null and p2 is null) then 1
            when (p1 = p2) then 1
            else 0
       end;

GRANT EXECUTE ON FUNCTION DB2EXT.EQUAL TO PUBLIC;

----------------------------------------------------------------------------
-- returns result expressionlist delimited by R0'0 ... R0'1 expressions
----------------------------------------------------------------------------

CREATE FUNCTION DB2EXT.resultExpr(e CLOB(32K))
RETURNS VARCHAR(32000)
LANGUAGE SQL NO EXTERNAL ACTION
DETERMINISTIC
RETURN case when posstr(e, 'R0''0') > 0  
            then substr(e, posstr(e, 'R0''0')+ 4, 
                           posstr(e, 'R0''1')-posstr(e,'R0''0')-4)
            else null
       end;

GRANT EXECUTE ON FUNCTION DB2EXT.resultExpr TO PUBLIC;

----------------------------------------------------------------------------
-- returns sort order expressionlist delimited by S0'0 ... S0'1 expressions
----------------------------------------------------------------------------

CREATE FUNCTION DB2EXT.orderExpr(e CLOB(32K))
RETURNS VARCHAR(32000)
LANGUAGE SQL NO EXTERNAL ACTION
DETERMINISTIC
RETURN case when posstr(e, 'S0''0') > 0  
            then substr(e, posstr(e, 'S0''0')+ 4, 
                           posstr(e, 'S0''1')-posstr(e,'S0''0')-4)
            else null
       end;

GRANT EXECUTE ON FUNCTION DB2EXT.orderExpr TO PUBLIC;

----------------------------------------------------------------------------
-- returns view key columns list delimited by V0'0 ... V0'1 expressions
----------------------------------------------------------------------------

CREATE FUNCTION DB2EXT.viewKeyColumns(e CLOB(32K))
RETURNS VARCHAR(32000)
LANGUAGE SQL NO EXTERNAL ACTION
DETERMINISTIC
RETURN case when posstr(e, 'V0''0') > 0  
            then substr(e, posstr(e, 'V0''0')+ 4, 
                           posstr(e, 'V0''1')-posstr(e,'V0''0')-4)
            else null
       end;

GRANT EXECUTE ON FUNCTION DB2EXT.viewKeyColumns TO PUBLIC;

----------------------------------------------------------------------------
-- returns number of conflicting text indexes on the same column
----------------------------------------------------------------------------

CREATE FUNCTION DB2EXT.ConflictIndexes(pTablesschema VARCHAR(128),
                                pTablename VARCHAR(128),
                                pColumnname VARCHAR(128),
                                pFunctionschema VARCHAR(128),
                                pFunctionname VARCHAR(128),
                                pAttributes VARCHAR(32000),
                                pCcsid INTEGER,
                                pLanguage VARCHAR(5),
                                pFormat integer,
                                pDocumentmodelFile VARCHAR(256),
                                pIndexconfig VARCHAR(1024)
                                )
RETURNS INTEGER
LANGUAGE SQL
READS SQL DATA
NO EXTERNAL ACTION
NOT DETERMINISTIC
RETURN select count(*)
       from DB2EXT.TTEXTCOLUMNS tc,
            DB2EXT.TTEXTINDEXES ti
       where tc.tableschema=pTablesschema and
             tc.tablename=pTablename      and
             tc.columnname=pColumnname    and
             Tc.indexidentifier=ti.indexidentifier and
             not (
                  db2ext.equal(tc.functionschema,pFunctionschema)=1 and
                  db2ext.equal(tc.functionname,pFunctionname)=1     and
                  db2ext.equal(DB2EXT.attributeExpr(ti.expressionlists),
                               pAttributes)=1       and	
                  tc.ccsid=pCcsid                   and
                  tc.language=pLanguage             and
                  tc.format=pFormat                 and
                  ti.configuration=pIndexconfig     and
                  db2ext.equal(pDocumentmodelfile,
                              (select modelfile 
                               from DB2EXT.TMODELS tm 
                               where Tc.indexidentifier=tm.indexidentifier))=1
                  )
;

GRANT EXECUTE ON FUNCTION DB2EXT.ConflictIndexes TO PUBLIC;

----------------------------------------------------------------------------
-- returns PCTFREE estimate
-- input: 1. actual number of documents
--        2. maximum number of documents (including deleted ones)
----------------------------------------------------------------------------

CREATE FUNCTION DB2EXT.PCTFREE(actualNumberDocs INTEGER,
                               maximumNumberDocs  INTEGER)
RETURNS INTEGER
LANGUAGE SQL NO EXTERNAL ACTION
DETERMINISTIC
RETURN 
   case 
     when actualNumberDocs=0 
--     # take maximal allowed value
       then 99
     when maximumNumberDocs>=actualNumberDocs and actualNumberDocs>0
--     # valid input values, avoid erroneous truncations !        
       then (cast(maximumNumberDocs as bigint)-actualNumberDocs)*100/maximumNumberDocs
--   # invalid input values 
     else null
   end;

GRANT EXECUTE ON FUNCTION DB2EXT.PCTFREE TO PUBLIC;

----------------------------------------------------------------------------
-- returns MAXIMUM CACHE SIZE estimate
-- input: 1. maximum number of documents
--        2. average cache row length
----------------------------------------------------------------------------

CREATE FUNCTION DB2EXT.MAXIMUM_CACHE_SIZE(maximumNumberDocs INTEGER,
                                          averageRowLength  INTEGER,
                                          numberOfColumns   INTEGER)
RETURNS INTEGER
LANGUAGE SQL NO EXTERNAL ACTION
DETERMINISTIC
RETURN 
   case 
     when maximumNumberDocs>0 and averageRowLength>0 and numberOfColumns>0
--     # valid input values, avoid erroneous truncations !        
       then (cast(maximumNumberDocs as bigint)*100/8 +
		       cast(maximumNumberDocs as bigint) *
--           # consider max 3 bytes alignment for variable types !
             (averageRowLength + 3 + 4*numberOfColumns)) /
            (1024*1024) + 1
--   # invalid input values 
     else null
   end;

GRANT EXECUTE ON FUNCTION DB2EXT.MAXIMUM_CACHE_SIZE TO PUBLIC;

----------------------------------------------------------------------------
-- external table function returning searchTermCounts 
--
-- only defined for INTEGER yet 
-- only for testing purposes
-- not a published interface yet
----------------------------------------------------------------------------

create function db2ext.textSearch_STC
        (
                pTextSearchArg    VARCHAR(4096),
                pIndexCreator     VARCHAR(128),
                pIndexName        VARCHAR(128),
                pResultFirstRow   INTEGER,
                pResultNumberRows INTEGER,
                pPrimKeyBinding   INTEGER
        )
        returns table
        (
                primKey          INTEGER,
                numberofmatches  INTEGER,
                score            DOUBLE,
                totalNbResults   INTEGER,
                searchTermCounts VARCHAR(4000)
        )
        return
           WITH tmptbl (tmpIndexName, tmpIndexProps) as 
                (SELECT C.indexidentifier, C.indexproperties 
                 FROM   db2ext.ttextcolumns C, db2ext.ttextindexes I
                 WHERE  C.indexidentifier=I.indexidentifier and
                        I.indexschema=pIndexCreator and
                        I.indexname=pIndexName
                )
           SELECT db2ext.unpack_text_key(TF.primkey, cast (NULL as INTEGER)), 
                  TF.numberofmatches, 
                  TF.score,
                  TF.totalNbResults,
                  TF.searchTermCounts
           FROM   tmptbl tmp, 
                  table( db2ext.textSearch_be1(
                         tmp.tmpIndexName, 
                         'DB2EXT', 
                         tmp.tmpIndexProps,
                         pTextSearchArg,
                         cast (NULL as varchar(4096)),
                         sysibm.pack_text_key(pPrimKeyBinding),
                         pResultFirstRow,
                         pResultNumberRows,
                         cast (NULL as INTEGER))) TF;


GRANT EXECUTE ON FUNCTION db2ext.textSearch_STC (
  VARCHAR(4096), VARCHAR(128), VARCHAR(128), INTEGER, INTEGER,
  INTEGER)
TO PUBLIC;


----------------------------------------------------------------------------
--
-- highlight UDF's
--
----------------------------------------------------------------------------
----------------------------------------------------------------------------
-- text type CLOB
----------------------------------------------------------------------------

create function db2ext.highlight
        (
                documentContent    CLOB(100K),
                hitInformation     BLOB(20K),
                hitProcInformation VARCHAR(1024)
        )
        returns CLOB(200K)
        specific CTE4D1
        external name 'libcteue.so!CteHighlight'
        language C
        parameter style db2sql
        deterministic
        not fenced
        returns null on null input
        no sql
        no external action
        scratchpad
        final call
        dbinfo
        disallow parallel;

GRANT EXECUTE ON FUNCTION db2ext.highlight (
  CLOB(100K), BLOB(20K), VARCHAR(1024))
TO PUBLIC;

----------------------------------------------------------------------------
-- text type BLOB
----------------------------------------------------------------------------

create function db2ext.highlight
        (
                documentContent    BLOB(100K),
                hitInformation     BLOB(20K),
                hitProcInformation VARCHAR(1024)
        )
        returns CLOB(200K)
        specific CTE4D2
        external name 'libcteue.so!CteHighlight'
        language C
        parameter style db2sql
        deterministic
        not fenced
        returns null on null input
        no sql
        no external action
        scratchpad
        final call
        dbinfo
        disallow parallel;

GRANT EXECUTE ON FUNCTION db2ext.highlight (
  BLOB(100K), BLOB(20K), VARCHAR(1024))
TO PUBLIC;

----------------------------------------------------------------------------
-- text type VARCHAR
----------------------------------------------------------------------------

create function db2ext.highlight
        (
                documentContent    VARCHAR(32672),
                hitInformation     BLOB(20K),
                hitProcInformation VARCHAR(1024)
        )
        returns CLOB(200K)
        specific CTE4D3
        return
          db2ext.highlight( cast( documentContent as CLOB(100K)),
                            hitInformation,
                            hitProcInformation)
;

GRANT EXECUTE ON FUNCTION db2ext.highlight (
  VARCHAR(32672), BLOB(20K), VARCHAR(1024))
TO PUBLIC;

----------------------------------------------------------------------------
-- text type VARCHAR FBD
----------------------------------------------------------------------------

create function db2ext.highlight
        (
                documentContent    VARCHAR(32672) FOR BIT DATA,
                hitInformation     BLOB(20K),
                hitProcInformation VARCHAR(1024)
        )
        returns CLOB(200K)
        specific CTE4D4
        return
          db2ext.highlight( cast( documentContent as BLOB(100K)),
                            hitInformation,
                            hitProcInformation)
;

GRANT EXECUTE ON FUNCTION db2ext.highlight (
  VARCHAR(32672) FOR BIT DATA, BLOB(20K), VARCHAR(1024))
TO PUBLIC;

