
------------------------------------------------------------------------
--  IBM*                                                                  
--  Licensed Materials - Property of IBM                                  
--  5765-F38                                                              
--  (C) Copyright IBM Corporation 2001,2003                               
--  All rights reserved.                                                  
--                                                                        
-- * Trademark of International Business Machines                         
------------------------------------------------------------------------

--**********************************************************************
--**********************************************************************
--**
--**  Product Name:      DB2 Net Search Extender
--**
--**  Source File Name:  ctedlctb.ddl
--**
--**  Description:       Table holds the proxy and connection timeout
--**			 information
--**			 Proxy type can have the value
--**			 1. "PROXY"
--**			 2. "SOCKS"
--**			 
--**			 The proxyTimeout specified the length of time
--**			 in seconds, that a connect operation waits be-
--**			 fore timing out and returning a timeout error.
--**
--**  Status:            Version 8.1.2
--**
--**********************************************************************
--**********************************************************************

--*---------------------------------------------------------------------
--* create 'proxy information' table
--*---------------------------------------------------------------------
CREATE TABLE DB2EXT.PROXYINFORMATION
                    (PROXYHOST	  VARCHAR(254) NOT NULL,
                     PROXYPORT	  VARCHAR(6),
                     PROXYTYPE    VARCHAR(10) WITH DEFAULT 'PROXY'
                                  CHECK(SYSFUN.UCASE(PROXYTYPE) = 'PROXY' OR
                                        SYSFUN.UCASE(PROXYTYPE) = 'SOCKS'
                                       ),
                     PROXYTIMEOUT INTEGER WITH DEFAULT
                    );

--*---------------------------------------------------------------------
--* grant select privileges on 'proxy information' table to public
--*---------------------------------------------------------------------
GRANT SELECT ON TABLE DB2EXT.PROXYINFORMATION TO PUBLIC;

------------------------------------------------------------------------

